function S2P=GPIB_VNA_get_S2P(id,my_type)

// id : Adresse GPIB du VNA
// my_type : Language (1)

select my_type,

// ================ ANRITSU 37000
case 1 then

	GPIB_write(id,"ONP");
      points_number=GPIB_read(id,1,30);
      points_number=evstr(points_number);   

	// Lecture du tableau des frquences
	GPIB_write(id,"FMB");
	GPIB_write(id,"MSB");
	GPIB_write(id,"OFV");
	frequence=GPIB_read_block(id,points_number,"FLOAT64");
      sparam=frequence;

	GPIB_write(id,"HLD");
	GPIB_write(id,"TRS");
	GPIB_write(id,"WFS");
	
	// WAIT VNA FINISH
	// GPIB_pause(1);
	// GPIB_write(id,"*RST")
	GPIB_write(id,"*OPC?")
	state=GPIB_read(id,1,1);
	state=evstr(state);
	while(state~=1)
		// GPIB_write(id,"*RST");
		// GPIB_write(id,"*OPC?");
		// GPIB_pause(5);
		state=GPIB_read(id,1,1);
		state=evstr(state);
	end

	// Lecture des 4 canaux
	for ch=1:4,
		GPIB_write(id,"CH"+string(ch));
	
		// Get corrected data
		GPIB_write(id,"OCD");

		GPIB_pause(1);
		data=GPIB_read_block(id,points_number*2,"FLOAT64");
		GPIB_pause(1);
		val=matrix(data,2,length(data)/2).';//.' POUR TRANSPOSE CONJUQUE
		val=val(:,1)+%i*val(:,2);
		sparam=[sparam,val];
	end;
	
	// Structuration  des donnes
	// sparam=[frequence,S11,S21,S12,S22];
	// On le met sous la forme d'une structure S2P
	// cf uW toolbox

	S2P=tlist(['S parameters';'frequency';'S11';'S12';'S21';'S22'],[],[],[],[],[]);
	S2P.frequency=sparam(:,1);
	S2P.S11=sparam(:,2);
	S2P.S12=sparam(:,3);
	S2P.S21=sparam(:,4);
	S2P.S22=sparam(:,5);

// ================ Other VNAs
else
	disp("Diver Analyzer not defined")
end;


endfunction;







